/* MEDIZINISCHES DIAGNOSE-SYSTEM */
/* FR KINDERKRANKHEITEN         */
/* APRIL 1987                    */
/* BEISPIELPROGRAMM - NICHT FR  */
/* PROFESSIONELLEN GEBRAUCH      */
/* mit dynamischer Datenbank     */

domains
  name,krankheit,indikation,symptom = symbol
  frage = string
  eingabe = char

database
  xpositiv(symptom)
  xnegativ(symptom)

predicates
  annahme(name,krankheit)
  symptom(name,indikation)
  antwort(eingabe)
  los
  positiv(frage,symptom)
  lsch_fakten
  erinnere(symptom,eingabe)
  frag(frage,symptom,eingabe)

clauses
  los:-
       clearwindow,
       annahme(Krankheit),!,
       write("Der Patient hat vermutlich
       ",Krankheit,"."),nl,
       lsch_fakten.

  los:-
       write("Bedaure, ich bin nicht in der Lage,"),nl,
       write("die Krankheit zu diagnostizieren."),nl.
       lsch_fakten.

  positiv(_,Symptom):-
       not(xnegativ(Symptom),!.

  positiv(Frage,Symptom):-
       not(xnegativ(Symptom)),
       frag(Frage,Symptom,Eingabe),
       Eingabe = 'j'.

  frag(Frage,Symptom,Eingabe):-
       write(Frage),nl,
       readchar(Eingabe),
       write(Eingabe),nl,
       erinnere(Symptom,Eingabe).

  erinnere(Symptom,'j'):-
       asserta(xpositiv(Symptom)).

  erinnere(Symptom,'n'):-
       asserta(xnegativ(Symptom)).

  lsch_fakten:-
       retract(xpositiv( _)),fail.

  lsch_fakten:-
       retract(xnegativ( _)),fail.

  lsch_fakten.

  symptom(fieber):-
       positiv("Hat der Patient Fieber (j/n)?",fieber).

  symptom(hautausschlag):-
       positiv("Hat der Patient Hautausschlag
        (j/n)?",hautausschlag).

  symptom(kopfschmerzen):-
       positiv("Hat der Patient Kopfschmerzen (j/n)?",
       kopfschmerzen).

  symptom(schnupfen):-
       positiv("Hat der Patient Schnupfen (j,n)?",schnupfen).

  symptom(bindehautentzndung):-
       positiv("Hat der Patient Bindehautentzndung (j/n)?",
       bindehautentzndung).

  symptom(husten):-
       positiv("Hat der Patient Husten (j/n)?", husten).

  symptom(gliederschmerzen):-
       positiv("Hat der Patient Gliederschmerzen (j/n)?",
       gliederschmerzen).

  symptom(schttelfrost):-
       positiv("Hat der Patient Schttelfrost (j/n)?",
       schttelfrost).

  symptom(halsschmerzen):-
       positiv("Hat der Patient Halsschmerzen (j/n)?",
       halsschmerzen).

  symptom(niesen):-
       positiv("Hat der Patient Niesen (j/n)?",niesen).

  symptom(geschwollene_drsen):-
       positiv("Hat der Patient geschwollene Drsen (j/n)?",
       geschwollene_drsen).

  annahme(masern):-
       symptom(fieber),
       symptom(husten),
       symptom(bindehautentzndung),
       symptom(schnupfen),
       symptom(hautausschlag).

  annahme(rteln):-
       symptom(fieber),
       symptom(kopfschmerzen),
       symptom(schnupfen),
       symptom(hautausschlag).

  annahme(grippe):-
       symptom(fieber),
       symptom(kopfschmerzen),
       symptom(gliederschmerzen),
       symptom(bindehautentzndung),
       symptom(schttelfrost),
       symptom(halsschmerzen),
       symptom(husten),
       symptom(schnupfen).

  annahme(erkltung):-
       symptom(kopfschmerzen),
       symptom(niesen),
       symptom(halsschmerzen),
       symptom(schttelfrost),
       symptom(schnupfen).

  annahme(mumps):-
       symptom(fieber),
       symptom(geschwollene_drsen).

  annahme(windpocken):-
       symptom(fieber),
       symptom(gliederschmerzen),
       symptom(schttelfrost),
       symptom(hautausschlag).

  annahme(keuchhusten):-
       symptom(husten),
       symptom(niesen),
       symptom(schnupfen).

  antwort(Eingabe):-
       readchar(Eingabe),
       write(Eingabe),nl.